"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var _ = require("underscore");
var React = require("react");
var icon_1 = require("./../../display/icon");
var validationWrapper_1 = require("../validationWrapper");
var classNames_1 = require("../../../utilities/classNames");
var TextInput = (function (_super) {
    tslib_1.__extends(TextInput, _super);
    function TextInput() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TextInput.prototype.focus = function () {
        if (this.input) {
            this.input.focus();
        }
    };
    TextInput.prototype.blur = function () {
        if (this.input) {
            this.input.blur();
        }
    };
    TextInput.prototype.render = function () {
        var _this = this;
        var validationMessage = this.props["data-validation-message"];
        var classes = classNames_1.ClassHelpers.classNames("armstrong-input", "text-input", this.props.className, {
            "text-input-disabled": this.props.disabled,
            "has-text-overlay-right": this.props.rightOverlayText !== undefined,
            "has-text-overlay-left": this.props.leftOverlayText !== undefined,
            "text-input-icon-left": this.props.leftIcon !== undefined,
            "text-input-icon-right": this.props.rightIcon !== undefined,
            "show-validation": (this.props.validationMode !== "none" && validationMessage)
        });
        var ps = _.omit(this.props, "className", "readonly", "rightOverlayText", "leftOverlayText", "type", "leftIcon", "rightIcon", "multiLine", "validationMode", "validationResults");
        return (React.createElement("div", { className: classes, title: validationMessage },
            this.props.leftIcon && React.createElement(icon_1.Icon, { className: "left-icon", icon: this.props.leftIcon }),
            this.props.leftOverlayText && React.createElement("div", { className: "input-overlay-text-left" }, this.props.leftOverlayText),
            !this.props.multiLine && React.createElement("input", tslib_1.__assign({ ref: function (r) { return _this.input = r; }, type: this.props.type || "text", readOnly: this.props.readonly }, ps, { placeholder: this.props.placeholder, required: this.props.required })),
            this.props.multiLine && React.createElement("textarea", tslib_1.__assign({ ref: function (r) { return _this.input = r; }, readOnly: this.props.readonly }, ps, { placeholder: this.props.placeholder })),
            this.props.rightOverlayText && React.createElement("div", { className: "input-overlay-text-right" }, this.props.rightOverlayText),
            this.props.rightIcon && React.createElement(icon_1.Icon, { className: "right-icon", icon: this.props.rightIcon }),
            this.props.children,
            React.createElement(validationWrapper_1.ValidationLabel, { message: validationMessage, mode: this.props.validationMode })));
    };
    TextInput.defaultProps = {
        validationMode: "none"
    };
    return TextInput;
}(React.Component));
exports.TextInput = TextInput;
