"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var _ = require("underscore");
var classNames_1 = require("../../utilities/classNames");
var ValidationWrapper = (function (_super) {
    tslib_1.__extends(ValidationWrapper, _super);
    function ValidationWrapper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ValidationWrapper.prototype.render = function () {
        var props = _.omit(this.props, "message", "validationMode");
        return (React.createElement("div", tslib_1.__assign({}, props, { className: classNames_1.ClassHelpers.classNames(this.props.className, { "show-validation": (this.props.validationMode !== "none" && !!this.props.message) }), title: this.props.message }),
            this.props.children,
            React.createElement(ValidationLabel, { message: this.props.message, mode: this.props.validationMode })));
    };
    return ValidationWrapper;
}(React.Component));
exports.ValidationWrapper = ValidationWrapper;
var ValidationLabel = (function (_super) {
    tslib_1.__extends(ValidationLabel, _super);
    function ValidationLabel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ValidationLabel.prototype.render = function () {
        if (!this.props.message || this.props.mode === "none") {
            return null;
        }
        var validationLabel = (React.createElement("label", { className: classNames_1.ClassHelpers.classNames("validation-message", "validation-message-" + this.props.mode), title: this.props.message }, (this.props.mode === "both" || this.props.mode === "below") && this.props.message));
        var Wrapper = this.props.wrapper;
        if (Wrapper) {
            return React.createElement(Wrapper, null, validationLabel);
        }
        return validationLabel;
    };
    return ValidationLabel;
}(React.Component));
exports.ValidationLabel = ValidationLabel;
